<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.18"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>XHXKit: XHXKit/Classes/XHXSafeData/XHXSafeData.m 源文件</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">XHXKit
   &#160;<span id="projectnumber">4.10.0.12</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- 制作者 Doxygen 1.8.18 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'搜索');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','搜索');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_x_h_x_safe_data_8m_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">XHXSafeData.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_x_h_x_safe_data_8m.html">浏览该文件的文档.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">//  XHXSafeData.m</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">//  XHXKit</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">//  Created by orange on 2019/10/21.</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#import &quot;<a class="code" href="_x_h_x_safe_data_8h.html">XHXSafeData.h</a>&quot;</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno"><a class="line" href="category_x_h_x_safe_data_07_08.html">   11</a></span>&#160;<span class="keyword">@interface </span><a class="code" href="interface_x_h_x_safe_data.html">XHXSafeData</a> ()</div>
<div class="line"><a name="l00012"></a><span class="lineno"><a class="line" href="category_x_h_x_safe_data_07_08.html#ad2ba06a51cc1bd4592e624aa4734e6c6">   12</a></span>&#160;<span class="keyword">@property</span> (nonatomic,strong)NSMutableArray *dataArray;</div>
<div class="line"><a name="l00013"></a><span class="lineno"><a class="line" href="interface_x_h_x_safe_data.html#a48fcde35d929039c31b88e800d6ed68f">   13</a></span>&#160;<span class="keyword">@property</span> (nonatomic,strong)dispatch_queue_t queue;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">@end</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keyword">@implementation </span><a class="code" href="interface_x_h_x_safe_data.html">XHXSafeData</a></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;- (instancetype)init</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;{</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <span class="keyword">self</span> = [<span class="keyword">super</span> init];</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="keywordflow">if</span> (<span class="keyword">self</span>) {</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        <span class="keywordflow">return</span> [<span class="keyword">self</span> <a class="code" href="interface_x_h_x_safe_data.html#ab7d1019317c7ce8b0cbf2328affdaf24">initWithDataArray</a>:nil];</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    }</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">self</span>;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;}</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;- (instancetype)initWithDataArray:(NSArray * __nullable)dataArray {</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keywordflow">if</span> (dataArray) {</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        <span class="keyword">self</span>.dataArray = [NSMutableArray arrayWithArray:dataArray];</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    }<span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="keyword">self</span>.dataArray = [NSMutableArray array];</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    }</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keyword">self</span>.queue = dispatch_queue_create(<span class="stringliteral">&quot;XHXKit.XHXSafeData.queue&quot;</span>, DISPATCH_QUEUE_SERIAL);</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">self</span>;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;}</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;- (void)insertItem:(<span class="keywordtype">id</span>)item refreshUI:(<span class="keywordtype">void</span>(^ __nullable)(<a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> *model))refreshUI {</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    dispatch_async(<span class="keyword">self</span>.queue, ^{</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keywordflow">if</span> (!item) {</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;            return ;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        }</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        <a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> *model = [[<a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> alloc] init];</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        model.<a class="code" href="interface_x_h_x_safe_data_model.html#a80f187ce208bb9256b811701919d13a7">operationType</a> = XHXSafeDataOperationTypeInsert;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        NSIndexPath *indexPath = [NSIndexPath indexPathForRow:self.dataArray.count inSection:0];</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        [<span class="keyword">self</span>.dataArray addObject:item];</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        model.<a class="code" href="interface_x_h_x_safe_data_model.html#a083d96499b090559eafdccd8e49968ca">dataArray</a> = [<span class="keyword">self</span>.dataArray copy];</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        model.<a class="code" href="interface_x_h_x_safe_data_model.html#aea2815dced2025c5c6b550b6ea5599bf">indexPaths</a> = @[indexPath];</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        [<span class="keyword">self</span> refreshUIWithModel:model refreshUI:refreshUI];</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    });</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;}</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160; </div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;- (void)insertItem:(<span class="keywordtype">id</span>)item atIndex:(NSUInteger)index refreshUI:(<span class="keywordtype">void</span>(^ __nullable)(<a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> *model))refreshUI {</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    dispatch_async(<span class="keyword">self</span>.queue, ^{</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        <span class="keywordflow">if</span> (!item) {</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;            return ;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        }</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        NSIndexPath *indexPath;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <span class="keywordflow">if</span> (index &gt;= <span class="keyword">self</span>.dataArray.count) {</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;            indexPath = [NSIndexPath indexPathForRow:self.dataArray.count inSection:0];</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;            [self.dataArray addObject:item];</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        }<span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;            [self.dataArray insertObject:item atIndex:index];</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            indexPath = [NSIndexPath indexPathForRow:index inSection:0];</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        }</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        <a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> *model = [[<a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> alloc] init];</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        model.<a class="code" href="interface_x_h_x_safe_data_model.html#a80f187ce208bb9256b811701919d13a7">operationType</a> = XHXSafeDataOperationTypeInsert;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        model.dataArray = [<span class="keyword">self</span>.dataArray copy];</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        model.indexPaths = @[indexPath];</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        [<span class="keyword">self</span> refreshUIWithModel:model refreshUI:refreshUI];</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    });</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;}</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;- (void)insertItems:(NSArray *)items refreshUI:(<span class="keywordtype">void</span>(^ __nullable)(<a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> *model))refreshUI {</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    dispatch_async(<span class="keyword">self</span>.queue, ^{</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="keywordflow">if</span> (!items.count) {</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;            return ;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        }</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        <a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> *model = [[<a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> alloc] init];</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        model.<a class="code" href="interface_x_h_x_safe_data_model.html#a80f187ce208bb9256b811701919d13a7">operationType</a> = XHXSafeDataOperationTypeInsert;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        NSMutableArray *indexPaths = [NSMutableArray array];</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        for (<span class="keywordtype">int</span> i = 0; i &lt; items.count; i ++) {</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;            NSIndexPath *indexPath = [NSIndexPath indexPathForRow:self.dataArray.count + i inSection:0];</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;            [indexPaths addObject:indexPath];</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        }</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        [<span class="keyword">self</span>.dataArray addObjectsFromArray:items];</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        model.dataArray = [<span class="keyword">self</span>.dataArray copy];</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        model.indexPaths = indexPaths;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        [<span class="keyword">self</span> refreshUIWithModel:model refreshUI:refreshUI];</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    });</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;}</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160; </div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;- (void)insertItems:(NSArray *)items atIndexs:(NSIndexSet *)indexs refreshUI:(<span class="keywordtype">void</span>(^ __nullable)(<a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> *model))refreshUI {</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    dispatch_async(<span class="keyword">self</span>.queue, ^{</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        <span class="keywordflow">if</span> (!items.count || !indexs.count || indexs.count != items.count) {</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;            return ;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        }</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        <a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> *model = [[<a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> alloc] init];</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        model.<a class="code" href="interface_x_h_x_safe_data_model.html#a80f187ce208bb9256b811701919d13a7">operationType</a> = XHXSafeDataOperationTypeInsert;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        NSMutableArray *indexPaths = [NSMutableArray array];</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        if (indexs.firstIndex &gt;= <span class="keyword">self</span>.dataArray.count) {</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;            for (NSInteger i = self.dataArray.count; i &lt; self.dataArray.count + indexs.count; i ++) {</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;                NSIndexPath *indexPath = [NSIndexPath indexPathForRow:i inSection:0];</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;                [indexPaths addObject:indexPath];</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            }</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;            [<span class="keyword">self</span>.dataArray addObjectsFromArray:items];</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;            model.dataArray = [<span class="keyword">self</span>.dataArray copy];</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;            model.indexPaths = indexPaths;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;            [<span class="keyword">self</span> refreshUIWithModel:model refreshUI:refreshUI];</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;            </div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        }<span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;            [<span class="keyword">self</span>.dataArray insertObjects:items atIndexes:indexs];</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;            model.dataArray = [<span class="keyword">self</span>.dataArray copy];</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;            [indexs enumerateIndexesUsingBlock:^(NSUInteger idx, BOOL * _Nonnull stop) {</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;                NSIndexPath *indexPath = [NSIndexPath indexPathForRow:idx inSection:0];</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;                [indexPaths addObject:indexPath];</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;                if (idx == indexs.count - 1) {</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;                    model.indexPaths = indexPaths;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;                    [<span class="keyword">self</span> refreshUIWithModel:model refreshUI:refreshUI];</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;                }</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;            }];</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;        }</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    });</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;}</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160; </div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;- (void)removeItemAtIndex:(NSUInteger)index refreshUI:(<span class="keywordtype">void</span>(^ __nullable)(<a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> *model))refreshUI {</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    dispatch_async(<span class="keyword">self</span>.queue, ^{</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        <span class="keywordflow">if</span> (index &gt;= <span class="keyword">self</span>.dataArray.count) {</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;            return ;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        }</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        [<span class="keyword">self</span>.dataArray removeObjectAtIndex:index];</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        <a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> *model = [[<a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> alloc] init];</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        model.<a class="code" href="interface_x_h_x_safe_data_model.html#a80f187ce208bb9256b811701919d13a7">operationType</a> = XHXSafeDataOperationTypeRemove;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        model.dataArray = [<span class="keyword">self</span>.dataArray copy];</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        NSIndexPath *indexPath = [NSIndexPath indexPathForRow:index inSection:0];</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        model.indexPaths = @[indexPath];</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;       [<span class="keyword">self</span> refreshUIWithModel:model refreshUI:refreshUI];</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    });</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;}</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160; </div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;- (void)removeItemsAtIndexs:(NSIndexSet *)indexs refreshUI:(<span class="keywordtype">void</span>(^ __nullable)(<a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> *model))refreshUI {</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    dispatch_async(<span class="keyword">self</span>.queue, ^{</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        <span class="keywordflow">if</span> (!<span class="keyword">self</span>.dataArray.count || !indexs.count || <span class="keyword">self</span>.dataArray.count &lt; indexs.count) {</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;            return ;</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        }</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        <a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> *model = [[<a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> alloc] init];</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        model.<a class="code" href="interface_x_h_x_safe_data_model.html#a80f187ce208bb9256b811701919d13a7">operationType</a> = XHXSafeDataOperationTypeRemove;</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        [<span class="keyword">self</span>.dataArray removeObjectsAtIndexes:indexs];</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        model.dataArray = [<span class="keyword">self</span>.dataArray copy];</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        NSMutableArray *indexPaths = [NSMutableArray array];</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        [indexs enumerateIndexesUsingBlock:^(NSUInteger idx, BOOL * _Nonnull stop) {</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;            NSIndexPath *indexPath = [NSIndexPath indexPathForRow:idx inSection:0];</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;            [indexPaths addObject:indexPath];</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;            if (idx == indexs.count - 1) {</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;                model.indexPaths = indexPaths;</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;                [self refreshUIWithModel:model refreshUI:refreshUI];</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;            }</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        }];</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    });</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;}</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160; </div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;- (void)moveItemAtIndex:(NSUInteger)index toIndex:(NSUInteger)toIndex refreshUI:(<span class="keywordtype">void</span>(^ __nullable)(<a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> *model))refreshUI {</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    dispatch_async(<span class="keyword">self</span>.queue, ^{</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        <span class="keywordflow">if</span> (!<span class="keyword">self</span>.dataArray.count || index &gt;= <span class="keyword">self</span>.dataArray.count || toIndex &gt;= <span class="keyword">self</span>.dataArray.count) {</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;            return ;</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        }</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        <a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> *model = [[<a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> alloc] init];</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        model.<a class="code" href="interface_x_h_x_safe_data_model.html#a80f187ce208bb9256b811701919d13a7">operationType</a> = XHXSafeDataOperationTypeMove;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        <span class="keywordtype">id</span> item = <span class="keyword">self</span>.dataArray[index];</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        [<span class="keyword">self</span>.dataArray insertObject:item atIndex:toIndex];</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        [<span class="keyword">self</span>.dataArray removeObjectAtIndex:index];</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;        model.dataArray = [<span class="keyword">self</span>.dataArray copy];</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        model.fromIndexPath = [NSIndexPath indexPathForRow:index inSection:0];</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        model.toIndexPath = [NSIndexPath indexPathForRow:toIndex inSection:0];</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;        [<span class="keyword">self</span> refreshUIWithModel:model refreshUI:refreshUI];</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    });</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;}</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160; </div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;- (void)refreshUIWithModel:(<a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> *)model refreshUI:(<span class="keywordtype">void</span>(^ __nullable)(<a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> *model))refreshUI {</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    dispatch_async(dispatch_get_main_queue(), ^{</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        <span class="keywordflow">if</span> (refreshUI) {</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;            refreshUI(model);</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;            return ;</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        }</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        <span class="keywordflow">if</span> (<span class="keyword">self</span>.<a class="code" href="interface_x_h_x_safe_data.html#ac9670bffc7b63952216a3e3be714c876">delegate</a> &amp;&amp; [<span class="keyword">self</span>.<a class="code" href="interface_x_h_x_safe_data.html#ac9670bffc7b63952216a3e3be714c876">delegate</a> respondsToSelector:<span class="keyword">@selector</span>(refreshUIWithModel:)]) {</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;            [<span class="keyword">self</span>.delegate refreshUIWithModel:model];</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        }</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    });</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;}</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160; </div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;- (void)resetDataArray:(NSArray *)dataArray refreshUI:(<span class="keywordtype">void</span>(^ __nullable)(<a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> *model))refreshUI {</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;    dispatch_async(<span class="keyword">self</span>.queue, ^{</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        <span class="keywordflow">if</span> (dataArray) {</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;            <span class="keyword">self</span>.dataArray = [NSMutableArray arrayWithArray:dataArray];</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;        }<span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;            <span class="keyword">self</span>.dataArray = [NSMutableArray array];</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        }</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        <a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> *model = [[<a class="code" href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a> alloc] init];</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;        model.<a class="code" href="interface_x_h_x_safe_data_model.html#a80f187ce208bb9256b811701919d13a7">operationType</a> = XHXSafeDataOperationTypeReload;</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        model.<a class="code" href="interface_x_h_x_safe_data_model.html#a083d96499b090559eafdccd8e49968ca">dataArray</a> = [<span class="keyword">self</span>.dataArray copy];</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        [<span class="keyword">self</span> refreshUIWithModel:model refreshUI:refreshUI];</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    });</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;}</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;<span class="keyword">@end</span></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="ainterface_x_h_x_safe_data_model_html"><div class="ttname"><a href="interface_x_h_x_safe_data_model.html">XHXSafeDataModel</a></div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_safe_data_model_8h_source.html#l00018">XHXSafeDataModel.h:19</a></div></div>
<div class="ttc" id="a_x_h_x_safe_data_8h_html"><div class="ttname"><a href="_x_h_x_safe_data_8h.html">XHXSafeData.h</a></div></div>
<div class="ttc" id="ainterface_x_h_x_safe_data_html"><div class="ttname"><a href="interface_x_h_x_safe_data.html">XHXSafeData</a></div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_safe_data_8h_source.html#l00018">XHXSafeData.h:19</a></div></div>
<div class="ttc" id="ainterface_x_h_x_safe_data_html_ab7d1019317c7ce8b0cbf2328affdaf24"><div class="ttname"><a href="interface_x_h_x_safe_data.html#ab7d1019317c7ce8b0cbf2328affdaf24">-[XHXSafeData initWithDataArray:]</a></div><div class="ttdeci">instancetype initWithDataArray:(NSArray *__nullable dataArray)</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_safe_data_8m_source.html#l00013">XHXSafeData.m:26</a></div></div>
<div class="ttc" id="ainterface_x_h_x_safe_data_model_html_aea2815dced2025c5c6b550b6ea5599bf"><div class="ttname"><a href="interface_x_h_x_safe_data_model.html#aea2815dced2025c5c6b550b6ea5599bf">XHXSafeDataModel::indexPaths</a></div><div class="ttdeci">NSArray&lt; NSIndexPath * &gt; * indexPaths</div><div class="ttdoc">tableView需要更新的indexPaths列表 section默认为0</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_safe_data_model_8h_source.html#l00025">XHXSafeDataModel.h:25</a></div></div>
<div class="ttc" id="ainterface_x_h_x_safe_data_model_html_a083d96499b090559eafdccd8e49968ca"><div class="ttname"><a href="interface_x_h_x_safe_data_model.html#a083d96499b090559eafdccd8e49968ca">XHXSafeDataModel::dataArray</a></div><div class="ttdeci">NSArray&lt; id &gt; * dataArray</div><div class="ttdoc">数据源列表</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_safe_data_model_8h_source.html#l00023">XHXSafeDataModel.h:23</a></div></div>
<div class="ttc" id="ainterface_x_h_x_safe_data_model_html_a80f187ce208bb9256b811701919d13a7"><div class="ttname"><a href="interface_x_h_x_safe_data_model.html#a80f187ce208bb9256b811701919d13a7">XHXSafeDataModel::operationType</a></div><div class="ttdeci">XHXSafeDataOperationType operationType</div><div class="ttdoc">操作类型</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_safe_data_model_8h_source.html#l00021">XHXSafeDataModel.h:21</a></div></div>
<div class="ttc" id="ainterface_x_h_x_safe_data_html_ac9670bffc7b63952216a3e3be714c876"><div class="ttname"><a href="interface_x_h_x_safe_data.html#ac9670bffc7b63952216a3e3be714c876">XHXSafeData::delegate</a></div><div class="ttdeci">id&lt; XHXSafeDataDelegate &gt; delegate</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_safe_data_8h_source.html#l00019">XHXSafeData.h:19</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_05f730b1f29a3e373a3d04cb5cb42ea7.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_2d533305e802e0a7e844b4ecd2e2bdb2.html">Classes</a></li><li class="navelem"><a class="el" href="dir_3ee286c5e24c0973e52617058301368a.html">XHXSafeData</a></li><li class="navelem"><a class="el" href="_x_h_x_safe_data_8m.html">XHXSafeData.m</a></li>
    <li class="footer">制作者
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.18 </li>
  </ul>
</div>
</body>
</html>
